//
//
//		mchusb.h
//
//
#pragma	once


#define	MPUSB_FAIL                  0
#define MPUSB_SUCCESS               1

#define MP_WRITE                    0
#define MP_READ                     1

#define	MAX_DEVICE					8


class	CMchUSB
{

public:

	CMchUSB();
	~CMchUSB();


	BOOL Open( int iDevice );
	void Close( int iDevice );
	BOOL IsOpen( int iDevice ){ return m_bOpen[iDevice]; }
	int	 Write( int iDevice, BYTE *pData, int nLength );
	int  Write( int iDevice, CString sData ){  return Write( iDevice, (BYTE*)sData.GetBuffer(1), sData.GetLength()); }
	int	 Read( int iDevice, BYTE *pData, int nLength, int nTimeOut );
	BOOL Initialize();


protected:
	
	struct HINSTANCE__ *		m_hDLL;
	HANDLE		m_hInPipe[MAX_DEVICE];
	HANDLE		m_hOutPipe[MAX_DEVICE];
	BOOL		m_bOpen[MAX_DEVICE];
	int			m_iDevCount;

	int			m_nWriteTimeOut;
	int			m_nReadTimeOut;

	//	֐|C^[
	DWORD (*MPUSBGetDLLVersion)(void);

	DWORD (*MPUSBGetDeviceCount)(PCHAR pVID_PID);

	HANDLE (*MPUSBOpen)(DWORD instance,         // Input
					 PCHAR pVID_PID,            // Input
					 PCHAR pEP,                 // Input
					 DWORD dwDir,               // Input
					 DWORD dwReserved);         // Input <Future Use>

	DWORD (*MPUSBRead)(HANDLE handle,           // Input
					PVOID pData,                // Output
					DWORD dwLen,                // Input
					PDWORD pLength,             // Output
					DWORD dwMilliseconds);      // Input

	DWORD (*MPUSBWrite)(HANDLE handle,          // Input
					 PVOID pData,               // Input
					 DWORD dwLen,               // Input
					 PDWORD pLength,            // Output
					 DWORD dwMilliseconds);     // Input

	DWORD (*MPUSBReadInt)(HANDLE handle,        // Input
					   PVOID pData,             // Output
					   DWORD dwLen,             // Input
					   PDWORD pLength,          // Output
					   DWORD dwMilliseconds);   // Input

	BOOL (*MPUSBClose)(HANDLE handle);


};


#ifndef		_MCHUSB_CPP
	extern	CMchUSB		gMchUSB;
#endif




